OpenTTD Source: RoadStopResolverObject Struct Reference

OpenTTD Source 15.0-beta1

Public Member Functions | Data Fields
RoadStopResolverObject Struct Reference

Road stop resolver. More...

`#include <newgrf_roadstop.h>`

Inheritance diagram for RoadStopResolverObject:

## Public Member Functions
| RoadStopResolverObject (const RoadStopSpec *roadstopspec, BaseStation *st, TileIndex tile, RoadType roadtype, StationType type, uint8_t view, CallbackID callback=CBID_NO_CALLBACK, uint32_t param1=0, uint32_t param2=0)
ScopeResolver * | GetScope (VarSpriteGroupScope scope=VSG_SCOPE_SELF, uint8_t relative=0) override
| Get a resolver for the scope.
TownScopeResolver * | GetTown ()
const SpriteGroup * | ResolveReal (const RealSpriteGroup *group) const override
| Get the real sprites of the grf.
Public Member Functions inherited from ResolverObject
| ResolverObject (const GRFFile *grffile, CallbackID callback=CBID_NO_CALLBACK, uint32_t callback_param1=0, uint32_t callback_param2=0)
| Resolver constructor.
const SpriteGroup * | Resolve ()
| Resolve SpriteGroup.
uint16_t | ResolveCallback ()
| Resolve callback.
uint32_t | GetRemainingTriggers () const
| Returns the waiting triggers that did not trigger any rerandomisation.
uint32_t | GetReseedSum () const
| Returns the OR-sum of all bits that need reseeding independent of the scope they were accessed with.
void | ResetState ()
| Resets the dynamic state of the resolver object.
virtual GrfSpecFeature | GetFeature () const
| Get the feature number being resolved for.
virtual uint32_t | GetDebugID () const
| Get an identifier for the item being resolved.

## Data Fields
RoadStopScopeResolver | roadstop_scope
| The stop scope resolver.
std::optional< TownScopeResolver > | town_scope = std::nullopt
| The town scope resolver (created on the first call).
Data Fields inherited from ResolverObject
ScopeResolver | default_scope
| Default implementation of the grf scope.
CallbackID | callback
| Callback being resolved.
uint32_t | callback_param1
| First parameter (var 10) of the callback.
uint32_t | callback_param2
| Second parameter (var 18) of the callback.
uint32_t | last_value
| Result of most recent DeterministicSpriteGroup (including procedure calls)
uint32_t | waiting_triggers
| Waiting triggers to be used by any rerandomisation. (scope independent)
uint32_t | used_triggers
| Subset of cur_triggers, which actually triggered some rerandomisation. (scope independent)
uint32_t | reseed [VSG_END]
| Collects bits to rerandomise while triggering triggers.
const GRFFile * | grffile
| GRFFile the resolved SpriteGroup belongs to.
const SpriteGroup * | root_spritegroup
| Root SpriteGroup to use for resolving.

## Detailed Description

Road stop resolver.

Definition at line 110 of file newgrf_roadstop.h.

## Constructor & Destructor Documentation

## ◆ RoadStopResolverObject()

RoadStopResolverObject::RoadStopResolverObject | ( | const RoadStopSpec * | roadstopspec,
|  | BaseStation * | st,
|  | TileIndex | tile,
|  | RoadType | roadtype,
|  | StationType | type,
|  | uint8_t | view,
|  | CallbackID | callback = `CBID_NO_CALLBACK`,
|  | uint32_t | param1 = `0`,
|  | uint32_t | param2 = `0`
| ) |  |

Definition at line 221 of file newgrf_roadstop.cpp.

## Member Function Documentation

## ◆ GetScope()

ScopeResolver * RoadStopResolverObject::GetScope | ( | VarSpriteGroupScope | scope = `VSG_SCOPE_SELF`,
|  | uint8_t | relative = `0`
| ) |  |
| inlineoverridevirtual

Get a resolver for the scope.

Returns
  The resolver for the requested scope.

Reimplemented from ResolverObject.

Definition at line 116 of file newgrf_roadstop.h.

References ResolverObject::GetScope(), roadstop_scope, VSG_SCOPE_PARENT, and VSG_SCOPE_SELF.

## ◆ GetTown()

TownScopeResolver * RoadStopResolverObject::GetTown | ( |  | ) |

Definition at line 251 of file newgrf_roadstop.cpp.

## ◆ ResolveReal()

const SpriteGroup * RoadStopResolverObject::ResolveReal | ( | const RealSpriteGroup * | group | ) | const
| overridevirtual

Get the real sprites of the grf.

Parameters

  group | Group to get.

Returns
  The available sprite group.

Reimplemented from ResolverObject.

Definition at line 214 of file newgrf_roadstop.cpp.

References RealSpriteGroup::loading.

## Field Documentation

## ◆ roadstop_scope

RoadStopScopeResolver RoadStopResolverObject::roadstop_scope

The stop scope resolver.

Definition at line 111 of file newgrf_roadstop.h.

Referenced by GetScope().

## ◆ town_scope

std::optional<TownScopeResolver> RoadStopResolverObject::town_scope = std::nullopt

The town scope resolver (created on the first call).

Definition at line 112 of file newgrf_roadstop.h.

The documentation for this struct was generated from the following files:

- src/newgrf_roadstop.h
- src/newgrf_roadstop.cpp